#include <unistd.h>
#include <sys/stat.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <allegro.h>
#include "edop.h"
#include "ymw.h"
#include "mem.h"
#include "gfxhelp.h"
#include "StatsDialog.h"

DIALOG stat_dlg[]=
{
     /* proc,                    x,   y,   w,   h,   fg,  bg,  key, flags,  d1,         d2, dp,                                                dp2,                          dp3 */
/*00*/{ d_shadow_box_proc,       0,   0,   350, 112, CTX, CFG, 0,   0,      0,          0,  NULL,                                              NULL,                         NULL },
/*01*/{ d_ctext_proc,            175, 2,   0,   0,   CTX, CFG, 0,   0,      0,          0,  "World Stats",                                     NULL,                         NULL },
/*02*/{ d_text_proc,             5,   20,  0,   8,   CTX, CFG, 0,   0,      0,          0,  NULL,                                              NULL,                         NULL },
/*03*/{ d_text_proc,             5,   29,  0,   8,   CTX, CFG, 0,   0,      0,          0,  NULL,                                              NULL,                         NULL },
/*04*/{ d_text_proc,             5,   38,  0,   8,   CTX, CFG, 0,   0,      0,          0,  NULL,                                              NULL,                         NULL },
/*05*/{ d_text_proc,             5,   47,  0,   8,   CTX, CFG, 0,   0,      0,          0,  NULL,                                              NULL,                         NULL },
/*06*/{ d_text_proc,             5,   56,  0,   8,   CTX, CFG, 0,   0,      0,          0,  NULL,                                              NULL,                         NULL },
/*07*/{ d_text_proc,             5,   65,  0,   8,   CTX, CFG, 0,   0,      0,          0,  NULL,                                              NULL,                         NULL },
/*08*/{ d_text_proc,             5,   74,  0,   8,   CTX, CFG, 0,   0,      0,          0,  NULL,                                              NULL,                         NULL },
/*09*/{ d_text_proc,             5,   83,  0,   8,   CTX, CFG, 0,   0,      0,          0,  NULL,                                              NULL,                         NULL },
/*10*/{ d_button_proc,           135, 92,  80,  15,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Finished",                                        NULL,                         NULL },
standarnd_dialog_chunks
};

int do_stat_dlg()
{
    char stuff[8][100];
    int j, k, num[8];

    for( j = 0; j < 8; j++ )
       num[j] = 0;

    num[0] = world.num_zones;
    for( j = 0; j < world.num_zones; j++ ){
       num[1] += world.zone[j].num_rooms;
       for( k = 0; k < world.zone[j].num_rooms; k++ ){
          num[2] += world.zone[j].room[k].num_doors;
          }
       num[3] += world.zone[j].num_mobiles;
       num[4] += world.zone[j].num_objects;
       num[5] += world.zone[j].num_shops;
       num[6] += world.zone[j].num_tags;
       }

    num[2] = num[2]/2;
    num[7] = calc_world_size( &world );

    sprintf( stuff[0], "Zones:    %d", num[0] );
    sprintf( stuff[1], "Rooms:    %d", num[1] );
    sprintf( stuff[2], "Doors:    %d", num[2] );
    sprintf( stuff[3], "Mobiles:  %d", num[3] );
    sprintf( stuff[4], "Objects:  %d", num[4] );
    sprintf( stuff[5], "Shops:    %d", num[5] );
    sprintf( stuff[6], "Tags:     %d", num[6] );
    sprintf( stuff[7], "Memory:   %d", num[7] );

    stat_dlg[2].dp = stuff[0];
    stat_dlg[3].dp = stuff[1];
    stat_dlg[4].dp = stuff[2];
    stat_dlg[5].dp = stuff[3];
    stat_dlg[6].dp = stuff[4];
    stat_dlg[7].dp = stuff[5];
    stat_dlg[8].dp = stuff[6];
    stat_dlg[9].dp = stuff[7];

    do_dialog( stat_dlg, 0 );

    return D_REDRAW;
}

int stat_dlg_init()
{
    set_colors( stat_dlg );
    centre_dialog( stat_dlg );

    return 0;
}
